{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            Copyright (c) 2018 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.Mask;

interface

uses
  {$IFNDEF LCLTMSWEB}
  System.Classes, Vcl.Mask
  {$ENDIF}
  {$IFDEF LCLTMSWEB}
  Classes, MaskEdit
  {$ENDIF}
  , WEBLib.Controls, WEBLib.StdCtrls, Web;

type
  {$IFNDEF LCLTMSWEB}
  [ComponentPlatforms(TMSWebPlatform)]
  {$ENDIF}
  TWebMaskEdit = class(TMaskEdit)
  private
    FElementFont: TElementFont;
    FElementID: TElementID;
    FChildOrder: integer;
    FElementPosition: TElementPosition;
    FElementClassName: TElementClassName;
    FAutoCompletion: TAutoCompletion;
    FAutoFocus: boolean;
    FCharCaseEx: TWebEditCharCase;
    FHideSelection: boolean;
    FShowFocus: boolean;
    FRequired: boolean;
    FTextDirection: TTextDirection;
  public
    constructor Create(AOwner: TComponent); overload; override;
    constructor Create(AId: string); reintroduce; overload;
  published
    property AutoCompletion: TAutoCompletion read FAutoCompletion write FAutoCompletion default acOff;
    property AutoFocus: boolean read FAutoFocus write FAutoFocus default false;
    property CharCase: TWebEditCharCase read FCharCaseEx write FCharCaseEx default wecNormal;
    property ChildOrder: integer read FChildOrder write FChildOrder default 0;
    property ElementClassName: TElementClassName read FElementClassName write FElementClassName;
    property ElementID: TElementID read FElementID write FElementID;
    property ElementFont: TElementFont read FElementFont write FElementFont default efProperty;
    property ElementPosition: TElementPosition read FElementPosition write FElementPosition default epAbsolute;
    property HideSelection: boolean read FHideSelection write FHideSelection default false;
    property Required: boolean read FRequired write FRequired default false;
    property ShowFocus: boolean read FShowFocus write FShowFocus default true;
    property TextDirection: TTextDirection read FTextDirection write FTextDirection default tdDefault;
  end;

implementation

{ TWebMaskEdit }

constructor TWebMaskEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCharCaseEx := wecNormal;
  FShowFocus := true;
  FTextDirection := tdDefault;
end;

constructor TWebMaskEdit.Create(AId: string);
begin
//
end;

end.
