unit libnotifications;

{$MODE ObjFPC}
{$H+}
{$modeswitch externalclass}

interface

uses
  SysUtils, JS, web, libserviceworkers, libvibrations;

type
  // Forward class definitions
  TJSNotification = class;
  TJSNotificationEvent = class;
  TJSNotificationOptions = class;
  TJSNotificationAction = class;
  TJSGetNotificationOptions = class;
  TJSNotificationEventInit = class;
  NotificationPermission = string;
  NotificationDirection = string;
  NotificationPermissionCallback = procedure(permission : NotificationPermission);
  
  { --------------------------------------------------------------------
    TJSNotificationOptions
    --------------------------------------------------------------------}
  
  TTJSNotificationActionDynArray = array of TJSNotificationAction;
  TJSNotificationOptions = class(TJSObject)
    dir : NotificationDirection;
    lang : string;
    body : string;
    tag : string;
    image : string;
    icon : string;
    badge : string;
    vibrate : VibratePattern;
    timestamp : NativeInt;
    renotify : boolean;
    silent : boolean;
    requireInteraction : boolean;
    data : JSValue;
    actions : TTJSNotificationActionDynArray;
  end;
  
  { --------------------------------------------------------------------
    TJSNotificationAction
    --------------------------------------------------------------------}
  
  TJSNotificationAction = class(TJSObject)
    action : string;
    title : string;
    icon : string;
  end;
  
  { --------------------------------------------------------------------
    TJSGetNotificationOptions
    --------------------------------------------------------------------}
  
  TJSGetNotificationOptions = class(TJSObject)
    tag : string;
  end;
  
  { --------------------------------------------------------------------
    TJSNotificationEventInit
    --------------------------------------------------------------------}
  
  TJSNotificationEventInit = class(TJSObject)
    notification : TJSNotification;
    action : string;
  end;

  { --------------------------------------------------------------------
    TJSNotification
    --------------------------------------------------------------------}
  
  TNativeIntDynArray = array of NativeInt;
  TJSNotification = class(TJSEventTarget)
  private
    Fpermission : NotificationPermission;
    FmaxActions : NativeInt;
    Ftitle : string;
    Fdir : NotificationDirection;
    Flang : string;
    Fbody : string;
    Ftag : string;
    Fimage : string;
    Ficon : string;
    Fbadge : string;
    Fvibrate : TNativeIntDynArray;
    Ftimestamp : NativeInt;
    Frenotify : boolean;
    Fsilent : boolean;
    FrequireInteraction : boolean;
    Fdata : JSValue;
    Factions : TTJSNotificationActionDynArray;
  public
    
      onclick : TJSEventHandler;
      onshow : TJSEventHandler;
      onerror : TJSEventHandler;
      onclose : TJSEventHandler;
    function requestPermission(deprecatedCallback : NotificationPermissionCallback): TJSPromise; overload;
    function requestPermission: TJSPromise; overload;
    procedure close;
    property permission : NotificationPermission read Fpermission;
    property maxActions : NativeInt read FmaxActions;
    property title : string read Ftitle;
    property dir : NotificationDirection read Fdir;
    property lang : string read Flang;
    property body : string read Fbody;
    property tag : string read Ftag;
    property image : string read Fimage;
    property icon : string read Ficon;
    property badge : string read Fbadge;
    property vibrate : TNativeIntDynArray read Fvibrate;
    property timestamp : NativeInt read Ftimestamp;
    property renotify : boolean read Frenotify;
    property silent : boolean read Fsilent;
    property requireInteraction : boolean read FrequireInteraction;
    property data : JSValue read Fdata;
    property actions : TTJSNotificationActionDynArray read Factions;
  end;
  
  { --------------------------------------------------------------------
    TJSServiceWorkerRegistration
    --------------------------------------------------------------------}
  
  TJSServiceWorkerRegistration = class
  private
  public
    function showNotification(title : string; options : TJSNotificationOptions): TJSPromise; overload;
    function showNotification(title : string): TJSPromise; overload;
    function getNotifications(filter : TJSGetNotificationOptions): TJSPromise; overload;
    function getNotifications: TJSPromise; overload;
  end;
  
  { --------------------------------------------------------------------
    TJSNotificationEvent
    --------------------------------------------------------------------}

  TJSNotificationEvent = class(TJSExtendableEvent)
  private
    Fnotification : TJSNotification;
    Faction : string;
  public
    property notification : TJSNotification read Fnotification;
    property action : string Read Faction;
  end;
  
  { --------------------------------------------------------------------
    TJSServiceWorkerGlobalScope
    --------------------------------------------------------------------}
  
  TJSServiceWorkerGlobalScope = class
  private
  public
      onnotificationclick : TJSEventHandler;
      onnotificationclose : TJSEventHandler;
  end;

implementation


{ TJSNotification }

procedure TJSNotification.close;
begin

end;

function TJSNotification.requestPermission(
  deprecatedCallback: NotificationPermissionCallback): TJSPromise;
begin
  Result := nil;
end;

function TJSNotification.requestPermission: TJSPromise;
begin
  Result := nil;
end;

{ TJSServiceWorkerRegistration }

function TJSServiceWorkerRegistration.getNotifications(
  filter: TJSGetNotificationOptions): TJSPromise;
begin
  Result := nil;
end;

function TJSServiceWorkerRegistration.getNotifications: TJSPromise;
begin
  Result := nil;
end;

function TJSServiceWorkerRegistration.showNotification(title: string;
  options: TJSNotificationOptions): TJSPromise;
begin
  Result := nil;
end;

function TJSServiceWorkerRegistration.showNotification(
  title: string): TJSPromise;
begin
  Result := nil;
end;

end.
