{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2020                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.ElectronCDS;

interface

uses
  Classes, js, libelectron, WEBLib.CDS, db, SysUtils;

type
  TElectronBaseClientDataSet = class;
  TElectronBaseClientDataProxy = class;

  TElectronDataFieldDefs = record
    FieldName: string;
    FieldType: TFieldType;
  end;

  TElectronDataFieldDefsArray = array of TElectronDataFieldDefs;

  TElectronNodeTLSSocketOptions = class(TPersistent)
  public
    constructor Create;
    function GetSSLObject: JSValue;
  published
    property UseProfile: Boolean read FUseProfile write FUseProfile;
    property SSLProfile: string read FSSLProfile write FSSLProfile;
    property RejectUnauthorized: Boolean read FRejectUnauthorized write FRejectUnauthorized;
    property CAPath: string read FCAPath write FCAPath;
    property CertPath: string read FCertPath write FCertPath;
    property Sigalgs: string read FSigalgs write FSigalgs;
    property ClientCertEngine: string read FClientCertEngine write FClientCertEngine;
    property CRLPath: string read FCRLPath write FCRLPath;
    property DHParam: string read FDHParam write FDHParam;
    property ECDHCurve: string read FECDHCurve write FECDHCurve;
    property KeyPath: string read FKeyPath write FKeyPath;
    property MaxVersion: string read FMaxVersion write FMaxVersion;
    property MinVersion: string read FMinVersion write FMinVersion;
    property Passphrase: string read FPassphrase write FPassphrase;
    property PFXPath: string read FPFXPath write FPFXPath;
  end;

  TElectronBaseQueryAllCallback = procedure(AResults: TJSArray) of object;
  TElectronBaseQuerySchemaCallback = procedure(AFields: TElectronDataFieldDefsArray) of object;
  TElectronBaseErrorEvent = procedure(AErrorMessage: string) of object;
  TElectronBaseClientDataProxySuccessCallback = procedure(AValue: JSValue) of object;

  TElectronBaseConnection = class(TComponent)
  protected
    function IsDisconnected: Boolean; virtual; abstract;
    procedure InitConnection; virtual; abstract;
    function GetClientConnection: TJSObject; virtual; abstract;
    procedure QueryAllRows(ATableName: string; ACallback: TElectronBaseQueryAllCallback); virtual; abstract;
    procedure QueryUpdate(AData: TJSObject; ATableName, AIndexName: string; ASuccess: TElectronBaseClientDataProxySuccessCallback; AError: TElectronBaseErrorEvent); virtual; abstract;
    procedure QueryDelete(AData: TJSObject; ATableName, AIndexName: string; ASuccess: TElectronBaseClientDataProxySuccessCallback; AError: TElectronBaseErrorEvent); virtual; abstract;
    procedure QueryInsert(Sender: TElectronBaseClientDataProxy; AData: TJSObject; ATAbleName: string; ABookmark: JSValue; ASuccess: TElectronBaseClientDataProxySuccessCallback; AError: TElectronBaseErrorEvent); virtual; abstract;
    procedure QuerySchema(ATableName: string; ACallback: TElectronBaseQuerySchemaCallback; AError: TElectronBaseErrorEvent); virtual; abstract;
    property User: string read FUser write FUser;
    property Host: string read FHost write FHost;
    property Password: string read FPassword write FPassword;
    property Port: Integer read FPort write FPort;
    property DatabaseName: string read FDatabaseName write FDatabaseName;
    property OnConnectionError: TElectronBaseErrorEvent read FOnConnectionError write FOnConnectionError;
  public
    constructor Create(aOwner : TComponent); override;
  end;

  TElectronBaseClientDataProxy = class(TDataProxy)
  protected
    function GetDataRequest(aOptions: TLoadOptions; aAfterRequest: TDataRequestEvent; aAfterLoad: TDatasetLoadEvent) : TDataRequest; override;
    function DoGetData(aRequest : TDataRequest) : Boolean; override;
    procedure DoOnError(AErrorCode: string);
    procedure DoDeleteSuccess(AValue: JSValue); virtual;
    procedure DoModifySuccess(AValue: JSValue); virtual;
    procedure DoInsertSuccess(AValue: JSValue); virtual;
    procedure HandleQueryAllCallback(AResults: TJSArray);
    procedure HandleSchemaCallback(AFields: TElectronDataFieldDefsArray);
    procedure ProcessUpdate(desc: TRecordUpdateDescriptor);
    // Dummy Abstract method
    function ProcessUpdateBatch(aBatch: TRecordUpdateBatch): Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    property CDS: TElectronBaseClientDataSet read FCDS;
  end;

  TElectronBaseClientDataSet = class(TClientDataSet)
  protected
    procedure DoAfterOpen; override;
    procedure DoError(AErrorCode: string);
    procedure SetActive(Value: Boolean); override;
    procedure AfterLoadDFMValues; override;
    procedure UpdateStarts;
    procedure UpdateEnds;
    procedure InternalClose; override;
    Function AddToChangeList(aChange : TUpdateStatus) : TRecordUpdateDescriptor ; override;
    property DataLoaded: Boolean read FDataLoaded write FDataLoaded;
    property IndexName: string read FIndexName write FIndexName;
    property TableName: string read FTableName write FTableName;
    property DBProxy: TElectronBaseClientDataProxy read FDBProxy write FDBProxy;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh(Force: Boolean=False); reintroduce;
  published
    property Connection: TElectronBaseConnection read FConnection write FConnection;
    property OnError: TElectronBaseErrorEvent read FOnError write FOnError;
  end;

procedure ReplaceJSONDate(var AData: TJSObject);

implementation
end.
