{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2020                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.ElectronMySQLCDS;

interface

uses
  Classes, JS, DB, WEBLib.ElectronCDS, libelectrondb, libelectronmysqldb, Types,
  SysUtils;

type
  TElectronMySQLConnection = class(TElectronBaseConnection)
  protected
    function GetClientConnection: TJSObject; override;
    function IsDisconnected: Boolean; override;
    procedure InitConnection; override;
    procedure HandleClientError(AError: TNodeMySQLErrorObject);
    procedure QueryAllRows(ATableName: string; ACallback: TElectronBaseQueryAllCallback); override;
    procedure QuerySchema(ATableName: string; ACallback: TElectronBaseQuerySchemaCallback; AError: TElectronBaseErrorEvent); override;
    procedure QueryUpdate(AData: TJSObject; ATableName, AIndexName: string; ASuccess: TElectronBaseClientDataProxySuccessCallback; AError: TElectronBaseErrorEvent); override;
    procedure QueryDelete(AData: TJSObject; ATableName, AIndexName: string; ASuccess: TElectronBaseClientDataProxySuccessCallback; AError: TElectronBaseErrorEvent); override;
    procedure QueryInsert(Sender: TElectronBaseClientDataProxy; AData: TJSObject; ATAbleName: string; ABookmark: JSValue; ASuccess: TElectronBaseClientDataProxySuccessCallback; AError: TElectronBaseErrorEvent); override;
  public
    constructor Create(aOwner : TComponent); override;
    destructor Destroy; override;
  published
    property User;
    property Host;
    property Password;
    property DatabaseName;
    property Port;
    property SSL: TElectronNodeTLSSocketOptions read FSSL write SetSSL;
    property OnConnectionError;
  end;

  TElectronMySQLClientDataProxy = class(TElectronBaseClientDataProxy)
  protected
    procedure DoInsertSuccess(AValue: JSValue); override;
  end;

  TElectronMySQLClientDataSet = class(TElectronBaseClientDataSet)
  public
    constructor Create(AOwner: TComponent); override;
    class function DefaultBlobDataToBytes(aValue : JSValue) : TBytes; override;
    class function DefaultBytesToBlobData(aValue : TBytes) : JSValue; override;
  published
    property IndexName;
    property TableName;
  end;

  function isInstanceOf(const aObject, aConstructor: JSValue): Boolean; assembler;

implementation
end.
