{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

{
  To investigate:
  -- If you move track bar too much, stopping in between,
     sometimes when you get back, the initial position is
     not reached. Need to investigate.
}

unit WEBLib.WebGLCustomControl;

interface

uses classes, Sysutils, WEBLib.Controls, WEBLib.webtools,
   WEBLib.graphics, web, webgl, js, libglmatrix;

type
  TGraphicsWebGLCustomControl = class(TCustomControl)
  protected
    procedure BindEvents; override;
    procedure UnbindEvents; override;
    function CreateElement: TJSElement; override;
    procedure Loaded; override;
    procedure SetParent(AValue: TControl); override;
    procedure ReinitColorBuffer;
    procedure Paint; override;
    function getRotationDegrees: double;

    procedure BindValuesAndDraw; virtual;
    procedure DoModelViewTransforms; virtual;

    procedure InitWebGL; virtual;

    // Override these to bind new control specific events
    // Sample code on how to do it is in BindEvents of TControl
    procedure BindWebGLEvents; virtual;
    procedure UnbindWebGLEvents; virtual;

    property IsInitialized: boolean read FisInitialized;
    property IsNotSupported: boolean read FIsNotSupported;
    // Disallow event binding to the enclosing DIV, for example in list which has its own events completely
    property IsDefaultEventBinding: boolean read FisDefaultEventBinding write FisDefaultEventBinding;

    procedure AnimatedRender(aTime: TJSDOMHighResTimeStamp);
    procedure setAnimated(aVal: boolean);
    property VertexShaderText: string read FVertexShaderText write FVertexShaderText;
    property FragmentShaderText: string read FFragmentShaderText write FFragmentShaderText;
    property Positions: TJSFloat32Array read FPositions write FPositions;
    property Colors: TJSFloat32Array read FColors write FColors;
    property Indices: TJSUint16Array read FIndices write FIndices;
    property IsAnimated: boolean read FIsAnimated write setAnimated;
    property BackgroundColor: TColor read FBackgroundColor write FBackgroundColor;
    property Rotation: double read FRotation;
    property RotationDegrees: double read getRotationDegrees;
  public
    procedure CreateInitialize; override;
    procedure ClearCanvas; virtual;
    procedure SetPerspective; virtual;
    procedure Translate(aVector: array of double); virtual;
    procedure Rotate(ARotation: double; onXAxis, onYAxis, onZAxis: boolean); virtual;
    procedure RotateIncremental(ARotation: double; onXAxis, onYAxis, onZAxis: boolean); virtual;

    function isBusy: boolean;
    procedure SaveModelViewState;
    procedure RestoreModelViewState;
  end;

  //utility
  procedure getWebGLColorParts(aColor: TColor; var R: double; var G: double; var B: double; var A: double);

implementation
end.

